package test.client.socket;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "test.client.socket", "test.client.socket.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "test.client.socket", "test.client.socket.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "test.client.socket.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.SocketWrapper _cltsock = null;
public static anywheresoftware.b4a.randomaccessfile.AsyncStreams _astreams = null;
public static String _ip = "";
public static int _port = 0;
public anywheresoftware.b4a.objects.ButtonWrapper _btn_client = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_status = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txt_out = null;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"Astreams",_astreams,"btn_client",mostCurrent._btn_client,"CltSock",_cltsock,"EditText1",mostCurrent._edittext1,"ip",_ip,"lbl_status",mostCurrent._lbl_status,"port",_port,"txt_out",mostCurrent._txt_out};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
try {
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent,33);
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 33;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(1);
 BA.debugLineNum = 34;BA.debugLine="Activity.LoadLayout(\"ClientForm\")";
Debug.ShouldStop(2);
mostCurrent._activity.LoadLayout("ClientForm",mostCurrent.activityBA);
 BA.debugLineNum = 35;BA.debugLine="EditText1.Text = ip";
Debug.ShouldStop(4);
mostCurrent._edittext1.setText((Object)(_ip));
 BA.debugLineNum = 36;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
try {
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent,42);
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 42;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(512);
 BA.debugLineNum = 44;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
try {
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent,38);
 BA.debugLineNum = 38;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(32);
 BA.debugLineNum = 40;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _astreams_newdata(byte[] _buffer) throws Exception{
try {
		Debug.PushSubsStack("AStreams_NewData (main) ","main",0,mostCurrent.activityBA,mostCurrent,46);
String _msg = "";
Debug.locals.put("Buffer", _buffer);
 BA.debugLineNum = 46;BA.debugLine="Sub AStreams_NewData (Buffer() As Byte)";
Debug.ShouldStop(8192);
 BA.debugLineNum = 47;BA.debugLine="Dim msg As String";
Debug.ShouldStop(16384);
_msg = "";Debug.locals.put("msg", _msg);
 BA.debugLineNum = 48;BA.debugLine="msg = BytesToString(Buffer, 0, Buffer.Length, \"UTF8\")";
Debug.ShouldStop(32768);
_msg = anywheresoftware.b4a.keywords.Common.BytesToString(_buffer,(int) (0),_buffer.length,"UTF8");Debug.locals.put("msg", _msg);
 BA.debugLineNum = 50;BA.debugLine="lbl_status.Text = msg";
Debug.ShouldStop(131072);
mostCurrent._lbl_status.setText((Object)(_msg));
 BA.debugLineNum = 52;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btn_client_click() throws Exception{
try {
		Debug.PushSubsStack("btn_client_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,54);
 BA.debugLineNum = 54;BA.debugLine="Sub btn_client_Click";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 55;BA.debugLine="CltSock.Initialize(\"Client\")";
Debug.ShouldStop(4194304);
Debug.DebugWarningEngine.CheckInitialize(_cltsock);_cltsock.Initialize("Client");
 BA.debugLineNum = 56;BA.debugLine="CltSock.Connect(ip,port,20000)";
Debug.ShouldStop(8388608);
_cltsock.Connect(processBA,_ip,_port,(int) (20000));
 BA.debugLineNum = 58;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _client_connected(boolean _constatus) throws Exception{
try {
		Debug.PushSubsStack("Client_Connected (main) ","main",0,mostCurrent.activityBA,mostCurrent,60);
Debug.locals.put("ConStatus", _constatus);
 BA.debugLineNum = 60;BA.debugLine="Sub Client_Connected(ConStatus As Boolean)";
Debug.ShouldStop(134217728);
 BA.debugLineNum = 61;BA.debugLine="If ConStatus = True Then";
Debug.ShouldStop(268435456);
if (_constatus==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 63;BA.debugLine="Astreams.Initialize(CltSock.InputStream, CltSock.OutputStream, \"AStreams\")";
Debug.ShouldStop(1073741824);
_astreams.Initialize(processBA,_cltsock.getInputStream(),_cltsock.getOutputStream(),"AStreams");
 BA.debugLineNum = 65;BA.debugLine="txt_out.Text = \"Test\"";
Debug.ShouldStop(1);
mostCurrent._txt_out.setText((Object)("Test"));
 BA.debugLineNum = 66;BA.debugLine="txt_out_EnterPressed";
Debug.ShouldStop(2);
_txt_out_enterpressed();
 }else {
 BA.debugLineNum = 68;BA.debugLine="Msgbox(LastException.Message, \"Error conectando\")";
Debug.ShouldStop(8);
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"Error conectando",mostCurrent.activityBA);
 };
 BA.debugLineNum = 72;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _edittext1_enterpressed() throws Exception{
try {
		Debug.PushSubsStack("EditText1_EnterPressed (main) ","main",0,mostCurrent.activityBA,mostCurrent,74);
 BA.debugLineNum = 74;BA.debugLine="Sub EditText1_EnterPressed";
Debug.ShouldStop(512);
 BA.debugLineNum = 75;BA.debugLine="ip = EditText1.Text";
Debug.ShouldStop(1024);
_ip = mostCurrent._edittext1.getText();
 BA.debugLineNum = 76;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 27045, new int[] {3}, "d234970f-88f9-4441-a4a4-e69a966ef317");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 23;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 27;BA.debugLine="Dim btn_client As Button";
mostCurrent._btn_client = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim lbl_status As Label";
mostCurrent._lbl_status = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim EditText1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim txt_out As EditText";
mostCurrent._txt_out = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 31;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 15;BA.debugLine="Dim CltSock As Socket";
_cltsock = new anywheresoftware.b4a.objects.SocketWrapper();
 //BA.debugLineNum = 16;BA.debugLine="Dim Astreams As AsyncStreams";
_astreams = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 18;BA.debugLine="Dim ip As String : ip = \"192.168.43.1\"";
_ip = "";
 //BA.debugLineNum = 18;BA.debugLine="Dim ip As String : ip = \"192.168.43.1\"";
_ip = "192.168.43.1";
 //BA.debugLineNum = 20;BA.debugLine="Dim port As Int: port = 5555";
_port = 0;
 //BA.debugLineNum = 20;BA.debugLine="Dim port As Int: port = 5555";
_port = (int) (5555);
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
public static String  _txt_out_enterpressed() throws Exception{
try {
		Debug.PushSubsStack("txt_out_EnterPressed (main) ","main",0,mostCurrent.activityBA,mostCurrent,77);
String _snewline = "";
byte[] _buffer = null;
 BA.debugLineNum = 77;BA.debugLine="Sub txt_out_EnterPressed";
Debug.ShouldStop(4096);
 BA.debugLineNum = 78;BA.debugLine="If Astreams.IsInitialized = False Then Return";
Debug.ShouldStop(8192);
if (_astreams.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
if (true) return "";};
 BA.debugLineNum = 79;BA.debugLine="If txt_out.Text.Length > 0 Then";
Debug.ShouldStop(16384);
if (mostCurrent._txt_out.getText().length()>0) { 
 BA.debugLineNum = 80;BA.debugLine="Dim sNewLine As String";
Debug.ShouldStop(32768);
_snewline = "";Debug.locals.put("sNewLine", _snewline);
 BA.debugLineNum = 81;BA.debugLine="sNewLine = txt_out.text & CRLF";
Debug.ShouldStop(65536);
_snewline = mostCurrent._txt_out.getText()+anywheresoftware.b4a.keywords.Common.CRLF;Debug.locals.put("sNewLine", _snewline);
 BA.debugLineNum = 82;BA.debugLine="Dim buffer() As Byte";
Debug.ShouldStop(131072);
_buffer = new byte[(int) (0)];
;Debug.locals.put("buffer", _buffer);
 BA.debugLineNum = 83;BA.debugLine="buffer = sNewLine.GetBytes(\"UTF8\")";
Debug.ShouldStop(262144);
_buffer = _snewline.getBytes("UTF8");Debug.locals.put("buffer", _buffer);
 BA.debugLineNum = 84;BA.debugLine="Astreams.Write(buffer)";
Debug.ShouldStop(524288);
_astreams.Write(_buffer);
 BA.debugLineNum = 85;BA.debugLine="CltSock.Close";
Debug.ShouldStop(1048576);
_cltsock.Close();
 BA.debugLineNum = 86;BA.debugLine="ToastMessageShow(\"Enviando:\" & sNewLine,False)";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Enviando:"+_snewline,anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 88;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
}
